/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package libraryfitnesse;

import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author student
 */
public class BookCatalog {

    private List<Book> books;

    private int currentCode;

    public BookCatalog() {
        this.books = new LinkedList<>();
        this.currentCode = 1;
    }

    public Book registerBook(String name, String isbn) {
        Book newBook = new Book(name, isbn, currentCode);
        this.currentCode++;
        addBook(newBook);
        return newBook;
    }

    private void addBook(Book book) {
        this.books.add(book);
    }

    private void removeBook(Book book) {
        this.books.remove(book);
    }

    public Book findByName(String name) {
        for (Book b : books) {
            if (b.getName().equals(name)) {
                return b;
            }
        }
        return null;
    }

    public Book findByLibCode(int code) {
        for (Book b : books) {
            if (b.getLibraryCode() == code) {
                return b;
            }
        }
        return null;
    }

    public Book find(Book book) {
        if (this.books.contains(book)) {
            return book;
        } else {
            return null;
        }
    }

    public List<Book> getAllBooks() {
        return this.books;
    }

    public void reset() {
        this.books.clear();
    }

}
