/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package libraryfitnesse;

import java.util.List;
import loans.AbstractLoan;

/**
 *
 * @author student
 */
public class Library {

    private BookCatalog bookCatalog;

    private LoanManager loanManager;

    private ReaderManager readerManager;

    public Library() {
        bookCatalog = new BookCatalog();
        loanManager = new LoanManager();
        readerManager = new ReaderManager();
    }

    public void registerReader(String firstName, String lastName) {
        this.readerManager.createReader(firstName, lastName);
    }

    public Book registerBook(String name, String isbn) {
        return this.bookCatalog.registerBook(name, isbn);
    }

    public void borrowBookLong(String bookName, String readerName, String from) {
        Book book = this.bookCatalog.findByName(bookName);
        Reader reader = this.readerManager.find(readerName);
        this.loanManager.createLongLoan(reader, book, DateConverter.convertStringToDateTime(from));
    }

    public void borrowBookShort(String bookName, String readerName, String from) {
        Book book = this.bookCatalog.findByName(bookName);
        Reader reader = this.readerManager.find(readerName);
        this.loanManager.createShortLoan(reader, book, DateConverter.convertStringToDateTime(from));
    }

    public void returnBook(String bookName, String toDate) {
        Book book = this.bookCatalog.findByName(bookName);
        this.loanManager.closeLoan(book, DateConverter.convertStringToDateTime(toDate));

    }

    public int getTotalFines(String readerWholeName, String now) {
        Reader reader = this.readerManager.find(readerWholeName);
        return this.loanManager.getTotalFines(reader, DateConverter.convertStringToDateTime(now));
    }

    public int getTotalPendingFines(String readerWholeName, String now) {
        Reader reader = this.readerManager.find(readerWholeName);
        return this.loanManager.getTotalOpenFines(reader, DateConverter.convertStringToDateTime(now));
    }

    public List<Reader> getAllReaders() {
        return this.readerManager.getReaders();
    }

    public List<Book> getAllBooks() {
        return this.bookCatalog.getAllBooks();
    }

    public List<AbstractLoan> getAllLoans() {
        return this.loanManager.getAllLoans();
    }

    public List<AbstractLoan> getOpenLoans(String dateTime) {
        return this.loanManager.getOpenLoans(DateConverter.convertStringToDateTime(dateTime));
    }

    public void clearLoans() {
        this.loanManager.reset();
    }

    public void clearBooks() {
        this.bookCatalog.reset();
    }

    public void clearReaders() {
        this.readerManager.reset();
    }
}
