/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package libraryfitnesse;

import java.util.LinkedList;
import java.util.List;

/**
 *
 * @author student
 */
public class ReaderManager {

    private List<Reader> readers;

    public ReaderManager() {
        this.readers = new LinkedList<>();
    }

    public void createReader(String firstName, String lastName) {
        Reader reader = new Reader(firstName, lastName);
        if (hasReader(reader)) {
            throw new IllegalArgumentException("The reader " + reader.getWholeName() + " is already registered");
        }
        addReader(reader);
    }

    private void addReader(Reader reader) {
        this.readers.add(reader);
    }

    private void removeReader(Reader reader) {
        this.readers.remove(reader);
    }

    public Reader find(String wholeName) {
        for (Reader r : this.readers) {
            if (r.getWholeName().equals(wholeName)) {
                return r;
            }
        }
        return null;
    }

    public boolean hasReader(Reader reader) {
        return this.readers.contains(reader);
    }

    public void reset() {
        this.readers.clear();
    }

    public List<Reader> getReaders() {
        return this.readers;
    }

}
