/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package loans;

import java.util.Objects;
import libraryfitnesse.Book;
import libraryfitnesse.Reader;
import org.joda.time.DateTime;

/**
 *
 * @author student
 */
public abstract class AbstractLoan {

    protected Book book;

    protected Reader reader;

    protected DateTime from;

    protected DateTime to;

    public AbstractLoan(Book book, Reader reader, DateTime from) {
        if (from == null) {
            throw new IllegalArgumentException("From date cant be null.");
        }

        this.book = book;
        this.reader = reader;
        this.from = from;

    }

//    public int getFees() {
//        Period period;
//        if (this.to == null) {
//            DateTime now = DateTime.now();
//            period = new Period(this.from, now);
//        } else {
//            period = new Period(this.from, this.to);
//        }
//        int fees = calculateFee(period);
//        return fees;
//
//    }
    public abstract int getFees();

    public abstract int getPreliminaryFees(DateTime time);

    // protected abstract int calculateFee(Period period);
    public boolean belongsToReader(Reader reader) {
        return this.reader.equals(reader);
    }

    public boolean belongsToBook(Book book) {
        return this.book.equals(book);
    }

    public void close(DateTime to) {
        this.to = to;
    }

    public boolean isClosed() {
        return (this.to != null);
    }

    public boolean isClosedBefore(DateTime time) {
        if (isClosed()) {
            if (time.isAfter(this.to)) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

    public boolean isOpenAt(DateTime time) {
        if (!isClosed()) {
            if (this.from.isBefore(time)) {
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }

    @Override
    public String toString() {
        return "AbstractLoan{" + "book=" + book + ", reader=" + reader + ", from=" + from + ", to=" + to + '}';
    }

    @Override
    public int hashCode() {
        int hash = 7;
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final AbstractLoan other = (AbstractLoan) obj;
        if (!Objects.equals(this.book, other.book)) {
            return false;
        }
        if (!Objects.equals(this.reader, other.reader)) {
            return false;
        }
        if (!Objects.equals(this.from, other.from)) {
            return false;
        }
        if (!Objects.equals(this.to, other.to)) {
            return false;
        }
        return true;
    }

    public Book getBook() {
        return book;
    }

    public Reader getReader() {
        return reader;
    }

    public DateTime getFrom() {
        return from;
    }

}
