/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package loans;

import libraryfitnesse.Book;
import libraryfitnesse.Reader;
import org.joda.time.DateTime;
import org.joda.time.Days;

/**
 *
 * @author student
 */
public class LongLoan extends AbstractLoan {

    public static final int DAY_FINE = 5;
    public static final int MAX_LENGTH_DAYS = 30;
    public static final int WEEK_PENALIZATION = 20;

    public LongLoan(Book book, Reader reader, DateTime from) {
        super(book, reader, from);
    }

    @Override
    public int getFees() {
        DateTime tempTo;
        if (this.to == null) {
            return 0;
        } else {
            tempTo = this.to;
        }
        int length = Days.daysBetween(this.from, tempTo).getDays();
        int overdueLength = (length - MAX_LENGTH_DAYS);
        if (length > MAX_LENGTH_DAYS) {
            int fine = overdueLength * DAY_FINE;
            //weekly penalization
            fine += (overdueLength / 7) * WEEK_PENALIZATION;

            return fine;
        } else {
            return 0;
        }
    }

    @Override
    public int getPreliminaryFees(DateTime timeAt) {
        int length = Days.daysBetween(this.from, timeAt).getDays();
        int overdueLength = (length - MAX_LENGTH_DAYS);
        if (length > MAX_LENGTH_DAYS) {
            int fine = overdueLength * DAY_FINE;
            //weekly penalization
            fine += (overdueLength % 7) * WEEK_PENALIZATION;

            return fine;
        } else {
            return 0;
        }
    }

}
