/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package loans;

import libraryfitnesse.Book;
import libraryfitnesse.Reader;
import org.joda.time.DateTime;
import org.joda.time.Hours;

/**
 *
 * @author student
 */
public class ShortLoan extends AbstractLoan {

    public static final int HOUR_FINE = 10;

    public static final int MAX_LENGTH = 8;

    public ShortLoan(Book book, Reader reader, DateTime from) {
        super(book, reader, from);

    }

    @Override
    public int getFees() {
        DateTime tempTo;
        if (this.to == null) {
            return 0;
        } else {
            tempTo = this.to;
        }

        int length = Hours.hoursBetween(this.from, tempTo).getHours();

        if (length > this.MAX_LENGTH) {
            return (length - this.MAX_LENGTH) * HOUR_FINE;
        } else {
            return 0;
        }
    }

    @Override
    public int getPreliminaryFees(DateTime time) {
        int length = Hours.hoursBetween(this.from, time).getHours();

        if (length > this.MAX_LENGTH) {
            return (length - this.MAX_LENGTH) * HOUR_FINE;
        } else {
            return 0;
        }
    }

}
